-- IndustrialTest
-- Copyright (C) 2026 mrkubax10

-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.

local S=minetest.get_translator("industrialtest")
industrialtest.Sawmill=industrialtest.internal.derive(industrialtest.SimpleElectricItemProcessor,{
	name="industrialtest:sawmill",
	description=S("Sawmill"),
	tiles={
		"industrialtest_machine_block.png",
		"industrialtest_machine_block.png",
		"industrialtest_machine_block.png",
		"industrialtest_machine_block.png",
		"industrialtest_machine_block.png",
		"industrialtest_machine_block.png^industrialtest_sawmill_front.png"
	},
	requiresWrench=true,
	active={
		tiles={
			"industrialtest_machine_block.png",
			"industrialtest_machine_block.png",
			"industrialtest_machine_block.png",
			"industrialtest_machine_block.png",
			"industrialtest_machine_block.png",
			"industrialtest_machine_block.png^industrialtest_sawmill_front_active.png"
		}
	},
	suplStorageLists={
		"sawdust"
	},
	capacity=industrialtest.api.lvPowerFlow*2,
	flow=industrialtest.api.lvPowerFlow,
	opPower=50,
	efficiency=0.5
})

function industrialtest.Sawmill.getCraftResult(self,itemstack)
	for _,provider in ipairs(industrialtest.api.sawmillRecipeProviders) do
		local result=provider(itemstack)
		if result then
			return result
		end
	end
	return {
		item="",
		time=0,
		src=ItemStack(itemstack:get_name())
	}
end

industrialtest.Sawmill:register()

minetest.register_craft({
	type="shaped",
	output="industrialtest:sawmill",
	recipe={
		{"",industrialtest.elementKeys.ironIngot,""},
		{industrialtest.elementKeys.stick,"industrialtest:machine_block",industrialtest.elementKeys.stick},
		{industrialtest.elementKeys.tinIngot,"industrialtest:electronic_circuit",industrialtest.elementKeys.tinIngot}
	}
})
